﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BallTrouble
{
    class Ball
    {
        private double x = 0.0;
        private double y = 0.0;
        private double r = 0.0;
        private double velocityX = 0.0;
        private double velocityY = 0.0;

        private Random rand = new Random();

        public Ball(double x, double y, double r)
        {
            this.x = x;
            this.y = y;
            this.r = r;

            this.velocityX = (0.5 - rand.NextDouble()) * 5.0;
            this.velocityY = (0.5 - rand.NextDouble()) * 5.0;
        }

        public double getX()
        {
            return x;
        }

        public double getY()
        {
            return y;
        }

        // Update the position of the ball based on its velocity.
        // Invert the velocity if we hit the wall of our bounding canvas.
        public void updatePosition(double maxX, double maxY)
        {
            x += velocityX;
            y += velocityY;

            if ((x <= r) || (x >= maxX - r))
                velocityX *= -1;
            if ((y <= r) || (y >= maxY - r))
                velocityY *= -1;
        }
    }
}
