﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

namespace Tasks
{
    class Tasks
    {
        private static Random rand = new Random();

        private static int getRandA()
        {
            System.Console.WriteLine("getRandA, starting");
            Thread.Sleep(6000);
            System.Console.WriteLine("getRandA, done");
            return rand.Next(100);
        }

        private static int getRandB()
        {
            System.Console.WriteLine("getRandB, starting");
            Thread.Sleep(4000);
            System.Console.WriteLine("getRandB, done");
            return rand.Next(100);
        }

        private static int getRandC()
        {
            System.Console.WriteLine("getRandC, starting");
            Thread.Sleep(2000);
            System.Console.WriteLine("getRandC, done");
            return rand.Next(100);
        }

        private static int square(int num)
        {
            System.Console.WriteLine("square, starting");
            Thread.Sleep(1000);
            System.Console.WriteLine("square, done");
            return num * num;
        }

        static void Main(string[] args)
        {
            // Create and start via a factory method in Task
            Task<int> taskA = Task.Factory.StartNew<int>(getRandA);
            Task<int> taskB = Task.Factory.StartNew<int>(getRandB);
            Task<int> taskC = Task.Factory.StartNew<int>(getRandC);

            // We can explicity wait for the set of tasks to finish
            //Task.WaitAll(taskA, taskB, taskC);

            // Or we using all their results also achieves the same thing
            System.Console.WriteLine("A = {0}, B = {1}, C = {2}", taskA.Result, taskB.Result, taskC.Result);

            // Example of chaining tasks together
            //Task<int> taskPost = taskC.ContinueWith(t => square(t.Result));
            //System.Console.WriteLine("A = {0}, B = {1}, C = {2}, post = {3}", taskA.Result, taskB.Result, taskC.Result, taskPost.Result);


        }
    }
}
